# dehub-server

This directory provides a simple Docker image which can be spun up to run a
dehub-enabled git http server (i.e. one in which incoming commits will be
verified prior to being accepted into the `main` branch).

The docker image is also being hosted on docker hub at `mediocregopher/dehub`.
Proper image tagging/versioning coming soon!

## Usage

Running the following:

```
docker run \
    --name dehub \
    -v /opt/dehub/repos:/repos \
    -v /opt/dehub/www:/var/www \
    -p 8080:80 \
    mediocregopher/dehub repo-a repo-b
```

Will start an http server on port 8080, using `/opt/dehub/repos` to store all
repo folders. It will then initialize repos at `/opt/dehub/repos/repo-a.git` and
`/opt/dehub/repos/repo-b.git`, if they arent already there.

If a volume for `/var/www` is given then that will be used as the root for all
non-git http requests.

## Contributors

The Dockerfile being used is based on
[gitbox](https://github.com/nmarus/docker-gitbox), so thank you to nmarus for
the great work there.

